package lib; //Test.java:

//nderungshistorie:
//2000-03-28  Knabe  Innere Klasse umbenannt MP -> Menpunkt
//1999-06-03  Knabe  Namenskonvention: i_imDialogTesten() ohne Praefix!
//1999-02-15  Knabe  private Daten mit Praefix _.
//1998-11-10  Knabe  Bei Ausnahme im Testling: e.printStackTrace()
//1998-10-05  Knabe  angepat an Fio.naechsteZahl() ohne Prfix,
//1998-06-04  Knabe  Erstellung

//Plne:
//1998-06-04  Knabe  Noch Auswahl per Abkrzung des Menpunkts einbauen.

/**Untersttzung fuer Dialog-Testtreiber*/
public class Test {


  /**Ein Menpunkt ist gekennzeichnet durch seinen Namen und durch die
    Methode, die ausgefhrt wird, wenn der Menpunkt aufgerufen wird.
  */
  public static abstract class Menpunkt {
    /** Erzeugt einen neuen Menpunkt und trgt ihn ein.
    */
    public Menpunkt(final String i_name)
    {
      _name = i_name;
      if(_anzahlMenuepunkte >= _mpArray.length){
        System.err.println("Test.java: Mehr als "+_mpArray.length
          +" Menuepunkte von Dialog-Testtreiber erzeugt");
        System.exit(1);
      }
      _mpArray[_anzahlMenuepunkte] = this; _anzahlMenuepunkte++;
    }//Menpunkt()

    /**Mu durch eine Testtreibermethode redefiniert werden*/
    public abstract void test() throws Exception;

    public  final String name(){return _name;}
    private final String _name;
  }//Menpunkt

  /** Bietet wiederholt das Menue der erzeugten MP-Objekte an und ruft
    * jeweils von dem ausgewaehlten Menuepunkt die test()-Methode auf.
    * Jegliche dabei auftretende Ausnahmen werden gemeldet, beenden aber nicht
    * die Menuewiederholung. Abgebrochen wird durch Auswahl des vordefinierten
    * Menuepunkts "0 = QUIT".
  */
  public static void imDialogTesten()
  {
    for(;;){ //Menueschleife
      for(int i=0; i<_anzahlMenuepunkte; i++){ //Menuepunkt anzeigen
        System.out.println(i + " = " + _mpArray[i].name());
      }
      System.out.print("Wahl ? ");
      final int wahlIndex;
      {try{wahlIndex= Fio.naechsteZahl();}
        catch(Fio.EndOfFile e){break;}
        catch(Exception e){
          System.out.println("Fehlerhafte Wahl wegen folgender Ausnahme:");
          System.out.println(e.toString()); continue;
        }
      }
      if(wahlIndex>=_anzahlMenuepunkte){ //fehlerhafte Wahl
        System.out.println("Ungltige Wahl " + wahlIndex + '!');
        continue;
      }
      //Test durchfuehren:
      final Menpunkt mp = _mpArray[wahlIndex];
      System.out.print(mp.name() + ": ");
      //Aufruf der zum Menpunkt gehrigen Aktion:
      {try{mp.test();}
        catch(QuitDesired e){break;}
        catch(Throwable e){
          e.printStackTrace();
        }
      }//try
    }//for
    System.out.println("Testende");
  }//imDialogTesten()

  public static class QuitDesired extends Exception {}

  private static int  _anzahlMenuepunkte = 0;
  private static Menpunkt[] _mpArray = new Menpunkt[51];
  static {
    _mpArray[0] = new Menpunkt("QUIT"){
      public void test() throws QuitDesired {throw new QuitDesired();}
    };
  }

} //class Test
